class control_bdir  {

# Basic directive control

inherit iwidgets::Entryfield Bean Node

public variable control_info_node
public variable directive
public variable directive_info_tree
public variable confnode


constructor {args} { 

Entryfield::constructor -width 12 

} {

eval itk_initialize $args -justify left

}


public method initialize {}
public method load {}
public method save {}

}

body control_bdir::initialize {} {

grid config [$this component entry] -sticky ew
array set conf [$control_info_node get_data]
set directive [$directive_info_tree ext_contents directive $conf(directive)]
configure -labeltext $conf(label_text)

if  [info exists conf(width)]  {$this configure -width $conf(width)}

# poner aqui tambien para configurar balloon help. Mirar old comanche         
}

body control_bdir::load {} {

set tmp [$confnode ext_contents type [$directive get_data name]]

$this delete 0 end

if { $tmp != "" } {

$this insert 0 [lrange [$tmp get_data dir_value] 1 end]
} else {

$this insert 0 [$directive get_data default]

}

}


body control_bdir::save {} {

set type [$directive get_data name]
set tmp [$confnode ext_contents type $type]


set dato [$this get]

if { $tmp != "" } {

if [string compare [$directive get_data default] $dato] {


$tmp set_data dir_value  [concat $type $dato]


} else { catch [$confnode remove $tmp] }

} else {

if [string compare [$directive get_data default] $dato] {

set mynode [ConfNodeAp $this-#auto ] 
$mynode set_data dir_class directive
$mynode set_data type $type
$mynode set_data dir_value  [concat $type $dato]
$mynode configure -title $dato
$confnode add $mynode

}
}


return $dato

}
