class HierNode {

 inherit VisNode
 public variable notebook
 public variable page

  constructor {cwin args} {
    VisNode::constructor $cwin

  } {
     
    eval configure $args 
  }     


  public method draw {ulVar midVar}
  public method view    

}

body HierNode::view {} {

$this configure -virgin 0; $this select; $notebook view $page

}


body HierNode::draw {ulVar midVar} {
  upvar $ulVar ul
  upvar $midVar mid
	
if { [ascendant] != "" } {  VisualRep::draw ul mid }

 $canvas bind $this <ButtonPress> " $this view"
 # $canvas bind $this <ButtonPress-3> "[$this get_data NameSpace] Notify RIGHT-CLICK $this"
 $canvas bind $this <Double-ButtonPress> " $this view;  $this toggle "
		    
 if ![info exists mid] {set mid(x) 13 ; set mid(y) 13; set ul(x) 2; set ul(y) 2}
  set lr(x) [expr $ul(x) + 2*($mid(x) - $ul(x))]

#2*($mid(x)-$ul(x))]
  set lr(y) $ul(y) 
  set mid(y)  $mid(y)


if { [ascendant] == "" } {

  	
	foreach obj [contents] {
  		
		$obj draw lr mid2
  		set id [$canvas create line \
             $mid(x) $mid(y) $mid(x)  $mid2(y)  $mid2(x) $mid2(y)   -fill black ]
										#grey
		$canvas lower $id
  
  		if {[$obj contents] != "" }  {
	
			if {[string compare [$obj cget -state] closed]} { 
  				set id [$canvas create oval \
  	    	       	[expr $mid(x) - 3 ] [expr $mid2(y) -3] [expr $mid(x) + 3 ] [expr $mid2(y) + 3]  \
				-outline black -fill white]
				#grey
			  	$canvas bind $id <ButtonPress-1> "$obj configure -virgin 0; $obj toggle"

				} else {
			  	set id [$canvas create oval \
      		       	[expr $mid(x) - 3 ] [expr $mid2(y) -3] [expr $mid(x) + 3 ] [expr $mid2(y) + 3]  \
				-outline black -fill yellow]
							#grey
			  	$canvas bind $id <ButtonPress-1> " $obj configure -virgin 0; $obj toggle"
				}
			
		} else {
	
		if [$obj cget -virgin] {
				set id [$canvas create oval \
      				[expr $mid(x) - 3 ] [expr $mid2(y) -3] [expr $mid(x) + 3 ] [expr $mid2(y) -3]  \
				-outline black -fill yellow]
						#grey
				$canvas bind $id <ButtonPress-1> "$obj configure -virgin 0; $obj toggle "
		}
		}
   }

	


} else {

  if {$state == "open"} {
  	
	foreach obj [contents] {
  		
		$obj draw lr mid2
  		set id [$canvas create line \
             $mid(x) $mid(y) $mid(x)  $mid2(y)  $mid2(x) $mid2(y)   -fill black ]
										#grey
		$canvas lower $id
  
  		if {[$obj contents] != "" }  {
	
			if {[string compare [$obj cget -state] closed]} { 
  				set id [$canvas create oval \
  	    	       	[expr $mid(x) - 3 ] [expr $mid2(y) -3] [expr $mid(x) + 3 ] [expr $mid2(y) + 3]  \
				-outline black -fill white]
				#grey
			  	$canvas bind $id <ButtonPress-1> "$obj configure -virgin 0; $obj toggle"

				} else {
			  	set id [$canvas create oval \
      		       	[expr $mid(x) - 3 ] [expr $mid2(y) -3] [expr $mid(x) + 3 ] [expr $mid2(y) + 3]  \
				-outline black -fill yellow]
							#grey
			  	$canvas bind $id <ButtonPress-1> " $obj configure -virgin 0; $obj toggle"
				}
			
		} else {
	
		if [$obj cget -virgin] {
				set id [$canvas create oval \
      				[expr $mid(x) - 3 ] [expr $mid2(y) -3] [expr $mid(x) + 3 ] [expr $mid2(y) -3]  \
				-outline black -fill yellow]
						#grey
				$canvas bind $id <ButtonPress-1> "$obj configure -virgin 0; $obj toggle "
		}
		}
   }
} 

	

}

       set ul(y) $lr(y)
}


